=== debian/changelog ===
hdf-eos4 (2.20v1.00-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:23:35 +0000

hdf-eos4 (2.20v1.00-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064091

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:25:00 +0000

hdf-eos4 (2.20v1.00-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.4
  * Add salsa.d.o. as VCS
  * Drop hdf4_l patch as merged
  * Mark libhdfes0, libhdfeos-dev as Multi-Arch: same

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 31 May 2018 14:09:40 +0100
